//   .mq4
//  "  "

#property copyright "mandorr@gmail.com"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Violet
#property indicator_color2 SkyBlue
#property indicator_color3 Silver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_style1 0
#property indicator_style2 0
#property indicator_style3 2

extern int  Stop=95;           //   
extern int  CountBars=3000;   //    (   20 )
extern bool ShowComment=true; //  

int    d, profit, total;

int    MyStop;
int    spread;
double size;

double buffer0[];
double buffer1[];
double buffer2[];

void init() {
   int MinStop;

   MinStop=MarketInfo(Symbol(),MODE_STOPLEVEL);
   MyStop=Stop; if (Stop<MinStop && MinStop>0) {MyStop=MinStop;}
   size=Stop*Point;

   spread=MarketInfo(Symbol(),MODE_SPREAD); if (spread<0) {spread=0;}

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,buffer0);
   SetIndexLabel(0," ");
   SetIndexDrawBegin(0,0);

   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,buffer1);
   SetIndexLabel(1," ");
   SetIndexDrawBegin(1,0);

   SetIndexStyle(2,DRAW_SECTION);
   SetIndexBuffer(2,buffer2);
   SetIndexLabel(2,"");
   SetIndexDrawBegin(2,0);

   IndicatorShortName("   ("+Stop+" )");
}

void deinit() {
   if (ShowComment) {Comment("");}
}

void start() {
   SetIndicator();
   if (ShowComment) {SetComment();} else {Comment("");}
}

void SetIndicator() {
   int count, d1, i, h_shift, l_shift;
   double h, l, H, L, reverse, reverse1;
   count=MathMin(CountBars,Bars-1);
   h=(High[count]+Low[count]+size)/2;
   l=(High[count]+Low[count]-size)/2;
   h_shift=count;
   l_shift=count;
   d=0; reverse=0; reverse1=0; profit=0; total=0;
   buffer0[count]=h;
   buffer1[count]=l;
   buffer2[count]=EMPTY_VALUE;
   for (i=count-1; i>=0; i--) {
      buffer0[i]=EMPTY_VALUE;
      buffer1[i]=EMPTY_VALUE;
      buffer2[i]=EMPTY_VALUE;
      d1=d;
      H=High[i];
      L=Low [i];
      if (H-L>size) {
         if (H-h>=l-L)    {d= 1; h=H; l=h-size; h_shift=i;}
         else             {d=-1; l=L; h=l+size; l_shift=i;}
      }
      else {
         if (H>h && L>=l) {d= 1; h=H; l=h-size; h_shift=i;}
         if (L<l && H<=h) {d=-1; l=L; h=l+size; l_shift=i;}
      }
      if (d<0) {buffer0[i]=h;}
      if (d>0) {buffer1[i]=l;}
      if (d>0 && d1<0) {
         buffer2[l_shift]=Low [l_shift];
         buffer0[i]=buffer0[i+1];
         reverse1=reverse;
         reverse=buffer0[i+1];
         if (reverse1>0) {total++; profit+=MathRound((reverse1-reverse)/Point);}
      }
      if (d<0 && d1>0) {
         buffer2[h_shift]=High[h_shift];
         buffer1[i]=buffer1[i+1];
         reverse1=reverse;
         reverse=buffer1[i+1];
         if (reverse1>0) {total++; profit+=MathRound((reverse-reverse1)/Point);}
      }
   }
   if (d>0) {buffer2[h_shift]=High[h_shift];}
   if (d<0) {buffer2[l_shift]=Low [l_shift];}
   //    
   if (reverse>0) {
      if (d>0) {profit+=MathRound((Close[i+1]-reverse)/Point);}
      if (d<0) {profit+=MathRound((reverse-Close[i+1])/Point);}
      reverse=0; reverse1=0;
   }
}

void SetComment() {
   string title;
   profit-=spread*total;
   title=" "; if (profit<0) {title=" ";}
   if (d<0 && buffer0[0]!=EMPTY_VALUE) {Comment(",     "+DoubleToStr(buffer0[0],Digits),"\n",title,profit," ");}
   if (d>0 && buffer1[0]!=EMPTY_VALUE) {Comment(",     " +DoubleToStr(buffer1[0],Digits),"\n",title,profit," ");}
}

